// Compiled by ClojureScript 1.9.562 {}
goog.provide('octet.spec.basic');
goog.require('cljs.core');
goog.require('octet.buffer');
goog.require('octet.spec');
octet.spec.basic.primitive_spec = (function octet$spec$basic$primitive_spec(size,readfn,writefn){
if(typeof octet.spec.basic.t_octet$spec$basic34499 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IFn}
 * @implements {octet.spec.ISpec}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
 * @implements {octet.spec.ISpecSize}
*/
octet.spec.basic.t_octet$spec$basic34499 = (function (size,readfn,writefn,meta34500){
this.size = size;
this.readfn = readfn;
this.writefn = writefn;
this.meta34500 = meta34500;
this.cljs$lang$protocol_mask$partition0$ = 393217;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
octet.spec.basic.t_octet$spec$basic34499.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34501,meta34500__$1){
var self__ = this;
var _34501__$1 = this;
return (new octet.spec.basic.t_octet$spec$basic34499(self__.size,self__.readfn,self__.writefn,meta34500__$1));
});

octet.spec.basic.t_octet$spec$basic34499.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34501){
var self__ = this;
var _34501__$1 = this;
return self__.meta34500;
});

octet.spec.basic.t_octet$spec$basic34499.prototype.call = (function (self__){
var self__ = this;
var self____$1 = this;
var s = self____$1;
return s;
});

octet.spec.basic.t_octet$spec$basic34499.prototype.apply = (function (self__,args34502){
var self__ = this;
var self____$1 = this;
return self____$1.call.apply(self____$1,[self____$1].concat(cljs.core.aclone.call(null,args34502)));
});

octet.spec.basic.t_octet$spec$basic34499.prototype.cljs$core$IFn$_invoke$arity$0 = (function (){
var self__ = this;
var s = this;
return s;
});

octet.spec.basic.t_octet$spec$basic34499.prototype.octet$spec$ISpecSize$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34499.prototype.octet$spec$ISpecSize$size$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.size;
});

octet.spec.basic.t_octet$spec$basic34499.prototype.octet$spec$ISpec$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34499.prototype.octet$spec$ISpec$read$arity$3 = (function (_,buff,pos){
var self__ = this;
var ___$1 = this;
var readed = self__.readfn.call(null,buff,pos);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [self__.size,readed], null);
});

octet.spec.basic.t_octet$spec$basic34499.prototype.octet$spec$ISpec$write$arity$4 = (function (_,buff,pos,value){
var self__ = this;
var ___$1 = this;
var G__34503_34504 = value;
if((G__34503_34504 == null)){
} else {
self__.writefn.call(null,buff,pos,G__34503_34504);
}

return self__.size;
});

octet.spec.basic.t_octet$spec$basic34499.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"size","size",-1555742762,null),new cljs.core.Symbol(null,"readfn","readfn",1394986672,null),new cljs.core.Symbol(null,"writefn","writefn",1052701163,null),new cljs.core.Symbol(null,"meta34500","meta34500",627910391,null)], null);
});

octet.spec.basic.t_octet$spec$basic34499.cljs$lang$type = true;

octet.spec.basic.t_octet$spec$basic34499.cljs$lang$ctorStr = "octet.spec.basic/t_octet$spec$basic34499";

octet.spec.basic.t_octet$spec$basic34499.cljs$lang$ctorPrWriter = (function (this__23805__auto__,writer__23806__auto__,opt__23807__auto__){
return cljs.core._write.call(null,writer__23806__auto__,"octet.spec.basic/t_octet$spec$basic34499");
});

octet.spec.basic.__GT_t_octet$spec$basic34499 = (function octet$spec$basic$primitive_spec_$___GT_t_octet$spec$basic34499(size__$1,readfn__$1,writefn__$1,meta34500){
return (new octet.spec.basic.t_octet$spec$basic34499(size__$1,readfn__$1,writefn__$1,meta34500));
});

}

return (new octet.spec.basic.t_octet$spec$basic34499(size,readfn,writefn,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Boolean type spec.
 */
octet.spec.basic.bool = (function (){
if(typeof octet.spec.basic.t_octet$spec$basic34505 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IFn}
 * @implements {octet.spec.ISpec}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
 * @implements {octet.spec.ISpecSize}
*/
octet.spec.basic.t_octet$spec$basic34505 = (function (meta34506){
this.meta34506 = meta34506;
this.cljs$lang$protocol_mask$partition0$ = 393217;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
octet.spec.basic.t_octet$spec$basic34505.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34507,meta34506__$1){
var self__ = this;
var _34507__$1 = this;
return (new octet.spec.basic.t_octet$spec$basic34505(meta34506__$1));
});

octet.spec.basic.t_octet$spec$basic34505.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34507){
var self__ = this;
var _34507__$1 = this;
return self__.meta34506;
});

octet.spec.basic.t_octet$spec$basic34505.prototype.call = (function (self__){
var self__ = this;
var self____$1 = this;
var s = self____$1;
return s;
});

octet.spec.basic.t_octet$spec$basic34505.prototype.apply = (function (self__,args34508){
var self__ = this;
var self____$1 = this;
return self____$1.call.apply(self____$1,[self____$1].concat(cljs.core.aclone.call(null,args34508)));
});

octet.spec.basic.t_octet$spec$basic34505.prototype.cljs$core$IFn$_invoke$arity$0 = (function (){
var self__ = this;
var s = this;
return s;
});

octet.spec.basic.t_octet$spec$basic34505.prototype.octet$spec$ISpecSize$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34505.prototype.octet$spec$ISpecSize$size$arity$1 = (function (__SHARP_){
var self__ = this;
var __SHARP___$1 = this;
return (1);
});

octet.spec.basic.t_octet$spec$basic34505.prototype.octet$spec$ISpec$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34505.prototype.octet$spec$ISpec$read$arity$3 = (function (__SHARP_,buff,pos){
var self__ = this;
var __SHARP___$1 = this;
var readed = octet.buffer.read_byte.call(null,buff,pos);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(1),(function (){var pred__34509 = cljs.core._EQ_;
var expr__34510 = readed;
if(cljs.core.truth_(pred__34509.call(null,(0),expr__34510))){
return false;
} else {
if(cljs.core.truth_(pred__34509.call(null,(1),expr__34510))){
return true;
} else {
return null;
}
}
})()], null);
});

octet.spec.basic.t_octet$spec$basic34505.prototype.octet$spec$ISpec$write$arity$4 = (function (_,buff,pos,value){
var self__ = this;
var ___$1 = this;
var value__$1 = (function (){var pred__34512 = cljs.core._EQ_;
var expr__34513 = value;
if(cljs.core.truth_(pred__34512.call(null,true,expr__34513))){
return (1);
} else {
if(cljs.core.truth_(pred__34512.call(null,false,expr__34513))){
return (0);
} else {
return (-1);
}
}
})();
octet.buffer.write_byte.call(null,buff,pos,value__$1);

return (1);
});

octet.spec.basic.t_octet$spec$basic34505.getBasis = (function (){
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"meta34506","meta34506",169847325,null)], null);
});

octet.spec.basic.t_octet$spec$basic34505.cljs$lang$type = true;

octet.spec.basic.t_octet$spec$basic34505.cljs$lang$ctorStr = "octet.spec.basic/t_octet$spec$basic34505";

octet.spec.basic.t_octet$spec$basic34505.cljs$lang$ctorPrWriter = (function (this__23805__auto__,writer__23806__auto__,opt__23807__auto__){
return cljs.core._write.call(null,writer__23806__auto__,"octet.spec.basic/t_octet$spec$basic34505");
});

octet.spec.basic.__GT_t_octet$spec$basic34505 = (function octet$spec$basic$__GT_t_octet$spec$basic34505(meta34506){
return (new octet.spec.basic.t_octet$spec$basic34505(meta34506));
});

}

return (new octet.spec.basic.t_octet$spec$basic34505(cljs.core.PersistentArrayMap.EMPTY));
})()
;
/**
 * Byte type spec.
 */
octet.spec.basic.byte$ = octet.spec.basic.primitive_spec.call(null,(1),octet.buffer.read_byte,octet.buffer.write_byte);
/**
 * Short type spec.
 */
octet.spec.basic.int16 = octet.spec.basic.primitive_spec.call(null,(2),octet.buffer.read_short,octet.buffer.write_short);
/**
 * Integer type spec.
 */
octet.spec.basic.int32 = octet.spec.basic.primitive_spec.call(null,(4),octet.buffer.read_int,octet.buffer.write_int);
/**
 * Long type spec.
 */
octet.spec.basic.int64 = octet.spec.basic.primitive_spec.call(null,(8),octet.buffer.read_long,octet.buffer.write_long);
/**
 * Float type spec
 */
octet.spec.basic.float$ = octet.spec.basic.primitive_spec.call(null,(4),octet.buffer.read_float,octet.buffer.write_float);
/**
 * Double type spec.
 */
octet.spec.basic.double$ = octet.spec.basic.primitive_spec.call(null,(8),octet.buffer.read_double,octet.buffer.write_double);
/**
 * Fixed size byte array type spec constructor.
 */
octet.spec.basic.bytes = (function octet$spec$basic$bytes(size){
if(typeof octet.spec.basic.t_octet$spec$basic34518 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {octet.spec.ISpec}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
 * @implements {octet.spec.ISpecSize}
*/
octet.spec.basic.t_octet$spec$basic34518 = (function (size,meta34519){
this.size = size;
this.meta34519 = meta34519;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
octet.spec.basic.t_octet$spec$basic34518.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34520,meta34519__$1){
var self__ = this;
var _34520__$1 = this;
return (new octet.spec.basic.t_octet$spec$basic34518(self__.size,meta34519__$1));
});

octet.spec.basic.t_octet$spec$basic34518.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34520){
var self__ = this;
var _34520__$1 = this;
return self__.meta34519;
});

octet.spec.basic.t_octet$spec$basic34518.prototype.octet$spec$ISpecSize$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34518.prototype.octet$spec$ISpecSize$size$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.size;
});

octet.spec.basic.t_octet$spec$basic34518.prototype.octet$spec$ISpec$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34518.prototype.octet$spec$ISpec$read$arity$3 = (function (_,buff,pos){
var self__ = this;
var ___$1 = this;
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [self__.size,octet.buffer.read_bytes.call(null,buff,pos,self__.size)], null);
});

octet.spec.basic.t_octet$spec$basic34518.prototype.octet$spec$ISpec$write$arity$4 = (function (_,buff,pos,value){
var self__ = this;
var ___$1 = this;
octet.buffer.write_bytes.call(null,buff,pos,self__.size,value);

return self__.size;
});

octet.spec.basic.t_octet$spec$basic34518.getBasis = (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"size","size",-1555742762,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol(null,"long","long",1469079434,null)], null)),new cljs.core.Symbol(null,"meta34519","meta34519",-1354165986,null)], null);
});

octet.spec.basic.t_octet$spec$basic34518.cljs$lang$type = true;

octet.spec.basic.t_octet$spec$basic34518.cljs$lang$ctorStr = "octet.spec.basic/t_octet$spec$basic34518";

octet.spec.basic.t_octet$spec$basic34518.cljs$lang$ctorPrWriter = (function (this__23805__auto__,writer__23806__auto__,opt__23807__auto__){
return cljs.core._write.call(null,writer__23806__auto__,"octet.spec.basic/t_octet$spec$basic34518");
});

octet.spec.basic.__GT_t_octet$spec$basic34518 = (function octet$spec$basic$bytes_$___GT_t_octet$spec$basic34518(size__$1,meta34519){
return (new octet.spec.basic.t_octet$spec$basic34518(size__$1,meta34519));
});

}

return (new octet.spec.basic.t_octet$spec$basic34518(size,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Unsinged int16 type spec.
 */
octet.spec.basic.uint16 = octet.spec.basic.primitive_spec.call(null,(2),octet.buffer.read_ushort,octet.buffer.write_ushort);
/**
 * Unsinged int32 type spec.
 */
octet.spec.basic.uint32 = octet.spec.basic.primitive_spec.call(null,(4),octet.buffer.read_uint,octet.buffer.write_uint);
/**
 * Unsinged byte type spec.
 */
octet.spec.basic.ubyte = octet.spec.basic.primitive_spec.call(null,(1),octet.buffer.read_ubyte,octet.buffer.write_ubyte);
/**
 * Unsinged int64 type spec.
 */
octet.spec.basic.uint64 = octet.spec.basic.primitive_spec.call(null,(8),octet.buffer.read_ulong,octet.buffer.write_ulong);
